//------------------------------------------------------------------------------
// Tumar CSP
// Copyright (c) 2011 Scientific Lab. Gamma Technologies. All rights reserved.
// SDK
// Verify CRL
//------------------------------------------------------------------------------
#include "ex_util.h"
//------------------------------------------------------------------------------
#define CMP_CRL "cmp_crl.crl"
//------------------------------------------------------------------------------
unsigned char *CRL;
//------------------------------------------------------------------------------
// Пользователь имеет контейнер с установленными сертификтами УЦ
// Задача:
// 1. Проверить подлинность СОС
//------------------------------------------------------------------------------
int main(void)
{
 int code;
 HCRYPTPROV hProv=0;
 DWORD sz;

 // Загружаем криптопровайдер
 code=LoadTumarCSP((char*)CSP_LIB); if (code) {printf("Load CSP error: %d\n",code); return 1;}
 //
 // Загружаем проверяемый СОС
 if (getFileLen(CMP_CRL,   &sz)) {printf("getFileLen error\r\n"); return 1;}
 CRL=(unsigned char*) calloc(sz+1,sizeof(unsigned char));
 if (readFile  (CMP_CRL,CRL,sz)) {printf("readFile error\r\n");   return 1;}
 //
 // Создаем контекст CSP
 if (!CPAcquireContext(&hProv,(char*)CSP_PROF,0,NULL)) {
   printf("CPAcquireContext Error: %0X\n",GetLastErrorCSP(0));
   return 1;
 }
 // Проверяем подлинность СОС
 if (!CPVerifySignature(hProv,0,CRL,sz,0,NULL,CRYPT_OBJECT_CRL)) {
   printf("CPVerifySignature Error: %0X\n",GetLastErrorCSP(hProv));
   return 1;
 }
 free(CRL);
 // Закрываем контекст CSP
 CPReleaseContext(hProv,0);
 printf("OK\n");
 return 0;
}
//------------------------------------------------------------------------------
